"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNcnOperatorStateEncoder = getNcnOperatorStateEncoder;
exports.getNcnOperatorStateDecoder = getNcnOperatorStateDecoder;
exports.getNcnOperatorStateCodec = getNcnOperatorStateCodec;
exports.decodeNcnOperatorState = decodeNcnOperatorState;
exports.fetchNcnOperatorState = fetchNcnOperatorState;
exports.fetchMaybeNcnOperatorState = fetchMaybeNcnOperatorState;
exports.fetchAllNcnOperatorState = fetchAllNcnOperatorState;
exports.fetchAllMaybeNcnOperatorState = fetchAllMaybeNcnOperatorState;
const web3_js_1 = require("@solana/web3.js");
const types_1 = require("../types");
function getNcnOperatorStateEncoder() {
    return (0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.getU64Encoder)()],
        ['ncn', (0, web3_js_1.getAddressEncoder)()],
        ['operator', (0, web3_js_1.getAddressEncoder)()],
        ['index', (0, web3_js_1.getU64Encoder)()],
        ['ncnOptInState', (0, types_1.getSlotToggleEncoder)()],
        ['operatorOptInState', (0, types_1.getSlotToggleEncoder)()],
        ['bump', (0, web3_js_1.getU8Encoder)()],
        ['reserved', (0, web3_js_1.getArrayEncoder)((0, web3_js_1.getU8Encoder)(), { size: 263 })],
    ]);
}
function getNcnOperatorStateDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.getU64Decoder)()],
        ['ncn', (0, web3_js_1.getAddressDecoder)()],
        ['operator', (0, web3_js_1.getAddressDecoder)()],
        ['index', (0, web3_js_1.getU64Decoder)()],
        ['ncnOptInState', (0, types_1.getSlotToggleDecoder)()],
        ['operatorOptInState', (0, types_1.getSlotToggleDecoder)()],
        ['bump', (0, web3_js_1.getU8Decoder)()],
        ['reserved', (0, web3_js_1.getArrayDecoder)((0, web3_js_1.getU8Decoder)(), { size: 263 })],
    ]);
}
function getNcnOperatorStateCodec() {
    return (0, web3_js_1.combineCodec)(getNcnOperatorStateEncoder(), getNcnOperatorStateDecoder());
}
function decodeNcnOperatorState(encodedAccount) {
    return (0, web3_js_1.decodeAccount)(encodedAccount, getNcnOperatorStateDecoder());
}
async function fetchNcnOperatorState(rpc, address, config) {
    const maybeAccount = await fetchMaybeNcnOperatorState(rpc, address, config);
    (0, web3_js_1.assertAccountExists)(maybeAccount);
    return maybeAccount;
}
async function fetchMaybeNcnOperatorState(rpc, address, config) {
    const maybeAccount = await (0, web3_js_1.fetchEncodedAccount)(rpc, address, config);
    return decodeNcnOperatorState(maybeAccount);
}
async function fetchAllNcnOperatorState(rpc, addresses, config) {
    const maybeAccounts = await fetchAllMaybeNcnOperatorState(rpc, addresses, config);
    (0, web3_js_1.assertAccountsExist)(maybeAccounts);
    return maybeAccounts;
}
async function fetchAllMaybeNcnOperatorState(rpc, addresses, config) {
    const maybeAccounts = await (0, web3_js_1.fetchEncodedAccounts)(rpc, addresses, config);
    return maybeAccounts.map((maybeAccount) => decodeNcnOperatorState(maybeAccount));
}
