/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  assertAccountExists,
  assertAccountsExist,
  combineCodec,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
  getAddressDecoder,
  getAddressEncoder,
  getArrayDecoder,
  getArrayEncoder,
  getStructDecoder,
  getStructEncoder,
  getU64Decoder,
  getU64Encoder,
  getU8Decoder,
  getU8Encoder,
  type Account,
  type Address,
  type Codec,
  type Decoder,
  type EncodedAccount,
  type Encoder,
  type FetchAccountConfig,
  type FetchAccountsConfig,
  type MaybeAccount,
  type MaybeEncodedAccount,
} from '@solana/web3.js';

export type Ncn = {
  discriminator: bigint;
  base: Address;
  admin: Address;
  operatorAdmin: Address;
  vaultAdmin: Address;
  slasherAdmin: Address;
  delegateAdmin: Address;
  metadataAdmin: Address;
  weightTableAdmin: Address;
  ncnProgramAdmin: Address;
  index: bigint;
  operatorCount: bigint;
  vaultCount: bigint;
  slasherCount: bigint;
  bump: number;
  reserved: Array<number>;
};

export type NcnArgs = {
  discriminator: number | bigint;
  base: Address;
  admin: Address;
  operatorAdmin: Address;
  vaultAdmin: Address;
  slasherAdmin: Address;
  delegateAdmin: Address;
  metadataAdmin: Address;
  weightTableAdmin: Address;
  ncnProgramAdmin: Address;
  index: number | bigint;
  operatorCount: number | bigint;
  vaultCount: number | bigint;
  slasherCount: number | bigint;
  bump: number;
  reserved: Array<number>;
};

export function getNcnEncoder(): Encoder<NcnArgs> {
  return getStructEncoder([
    ['discriminator', getU64Encoder()],
    ['base', getAddressEncoder()],
    ['admin', getAddressEncoder()],
    ['operatorAdmin', getAddressEncoder()],
    ['vaultAdmin', getAddressEncoder()],
    ['slasherAdmin', getAddressEncoder()],
    ['delegateAdmin', getAddressEncoder()],
    ['metadataAdmin', getAddressEncoder()],
    ['weightTableAdmin', getAddressEncoder()],
    ['ncnProgramAdmin', getAddressEncoder()],
    ['index', getU64Encoder()],
    ['operatorCount', getU64Encoder()],
    ['vaultCount', getU64Encoder()],
    ['slasherCount', getU64Encoder()],
    ['bump', getU8Encoder()],
    ['reserved', getArrayEncoder(getU8Encoder(), { size: 263 })],
  ]);
}

export function getNcnDecoder(): Decoder<Ncn> {
  return getStructDecoder([
    ['discriminator', getU64Decoder()],
    ['base', getAddressDecoder()],
    ['admin', getAddressDecoder()],
    ['operatorAdmin', getAddressDecoder()],
    ['vaultAdmin', getAddressDecoder()],
    ['slasherAdmin', getAddressDecoder()],
    ['delegateAdmin', getAddressDecoder()],
    ['metadataAdmin', getAddressDecoder()],
    ['weightTableAdmin', getAddressDecoder()],
    ['ncnProgramAdmin', getAddressDecoder()],
    ['index', getU64Decoder()],
    ['operatorCount', getU64Decoder()],
    ['vaultCount', getU64Decoder()],
    ['slasherCount', getU64Decoder()],
    ['bump', getU8Decoder()],
    ['reserved', getArrayDecoder(getU8Decoder(), { size: 263 })],
  ]);
}

export function getNcnCodec(): Codec<NcnArgs, Ncn> {
  return combineCodec(getNcnEncoder(), getNcnDecoder());
}

export function decodeNcn<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress>
): Account<Ncn, TAddress>;
export function decodeNcn<TAddress extends string = string>(
  encodedAccount: MaybeEncodedAccount<TAddress>
): MaybeAccount<Ncn, TAddress>;
export function decodeNcn<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress> | MaybeEncodedAccount<TAddress>
): Account<Ncn, TAddress> | MaybeAccount<Ncn, TAddress> {
  return decodeAccount(
    encodedAccount as MaybeEncodedAccount<TAddress>,
    getNcnDecoder()
  );
}

export async function fetchNcn<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<Account<Ncn, TAddress>> {
  const maybeAccount = await fetchMaybeNcn(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}

export async function fetchMaybeNcn<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<MaybeAccount<Ncn, TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeNcn(maybeAccount);
}

export async function fetchAllNcn(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<Account<Ncn>[]> {
  const maybeAccounts = await fetchAllMaybeNcn(rpc, addresses, config);
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}

export async function fetchAllMaybeNcn(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<MaybeAccount<Ncn>[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeNcn(maybeAccount));
}
