/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  assertAccountExists,
  assertAccountsExist,
  combineCodec,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
  getAddressDecoder,
  getAddressEncoder,
  getArrayDecoder,
  getArrayEncoder,
  getStructDecoder,
  getStructEncoder,
  getU16Decoder,
  getU16Encoder,
  getU64Decoder,
  getU64Encoder,
  getU8Decoder,
  getU8Encoder,
  type Account,
  type Address,
  type Codec,
  type Decoder,
  type EncodedAccount,
  type Encoder,
  type FetchAccountConfig,
  type FetchAccountsConfig,
  type MaybeAccount,
  type MaybeEncodedAccount,
} from '@solana/web3.js';

export type Operator = {
  discriminator: bigint;
  base: Address;
  admin: Address;
  ncnAdmin: Address;
  vaultAdmin: Address;
  delegateAdmin: Address;
  metadataAdmin: Address;
  voter: Address;
  index: bigint;
  ncnCount: bigint;
  vaultCount: bigint;
  operatorFeeBps: number;
  bump: number;
  reservedSpace: Array<number>;
};

export type OperatorArgs = {
  discriminator: number | bigint;
  base: Address;
  admin: Address;
  ncnAdmin: Address;
  vaultAdmin: Address;
  delegateAdmin: Address;
  metadataAdmin: Address;
  voter: Address;
  index: number | bigint;
  ncnCount: number | bigint;
  vaultCount: number | bigint;
  operatorFeeBps: number;
  bump: number;
  reservedSpace: Array<number>;
};

export function getOperatorEncoder(): Encoder<OperatorArgs> {
  return getStructEncoder([
    ['discriminator', getU64Encoder()],
    ['base', getAddressEncoder()],
    ['admin', getAddressEncoder()],
    ['ncnAdmin', getAddressEncoder()],
    ['vaultAdmin', getAddressEncoder()],
    ['delegateAdmin', getAddressEncoder()],
    ['metadataAdmin', getAddressEncoder()],
    ['voter', getAddressEncoder()],
    ['index', getU64Encoder()],
    ['ncnCount', getU64Encoder()],
    ['vaultCount', getU64Encoder()],
    ['operatorFeeBps', getU16Encoder()],
    ['bump', getU8Encoder()],
    ['reservedSpace', getArrayEncoder(getU8Encoder(), { size: 261 })],
  ]);
}

export function getOperatorDecoder(): Decoder<Operator> {
  return getStructDecoder([
    ['discriminator', getU64Decoder()],
    ['base', getAddressDecoder()],
    ['admin', getAddressDecoder()],
    ['ncnAdmin', getAddressDecoder()],
    ['vaultAdmin', getAddressDecoder()],
    ['delegateAdmin', getAddressDecoder()],
    ['metadataAdmin', getAddressDecoder()],
    ['voter', getAddressDecoder()],
    ['index', getU64Decoder()],
    ['ncnCount', getU64Decoder()],
    ['vaultCount', getU64Decoder()],
    ['operatorFeeBps', getU16Decoder()],
    ['bump', getU8Decoder()],
    ['reservedSpace', getArrayDecoder(getU8Decoder(), { size: 261 })],
  ]);
}

export function getOperatorCodec(): Codec<OperatorArgs, Operator> {
  return combineCodec(getOperatorEncoder(), getOperatorDecoder());
}

export function decodeOperator<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress>
): Account<Operator, TAddress>;
export function decodeOperator<TAddress extends string = string>(
  encodedAccount: MaybeEncodedAccount<TAddress>
): MaybeAccount<Operator, TAddress>;
export function decodeOperator<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress> | MaybeEncodedAccount<TAddress>
): Account<Operator, TAddress> | MaybeAccount<Operator, TAddress> {
  return decodeAccount(
    encodedAccount as MaybeEncodedAccount<TAddress>,
    getOperatorDecoder()
  );
}

export async function fetchOperator<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<Account<Operator, TAddress>> {
  const maybeAccount = await fetchMaybeOperator(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}

export async function fetchMaybeOperator<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<MaybeAccount<Operator, TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeOperator(maybeAccount);
}

export async function fetchAllOperator(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<Account<Operator>[]> {
  const maybeAccounts = await fetchAllMaybeOperator(rpc, addresses, config);
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}

export async function fetchAllMaybeOperator(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<MaybeAccount<Operator>[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeOperator(maybeAccount));
}
