/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  assertAccountExists,
  assertAccountsExist,
  combineCodec,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
  getAddressDecoder,
  getAddressEncoder,
  getArrayDecoder,
  getArrayEncoder,
  getStructDecoder,
  getStructEncoder,
  getU64Decoder,
  getU64Encoder,
  getU8Decoder,
  getU8Encoder,
  type Account,
  type Address,
  type Codec,
  type Decoder,
  type EncodedAccount,
  type Encoder,
  type FetchAccountConfig,
  type FetchAccountsConfig,
  type MaybeAccount,
  type MaybeEncodedAccount,
} from '@solana/web3.js';
import {
  getSlotToggleDecoder,
  getSlotToggleEncoder,
  type SlotToggle,
  type SlotToggleArgs,
} from '../types';

export type OperatorVaultTicket = {
  discriminator: bigint;
  operator: Address;
  vault: Address;
  index: bigint;
  state: SlotToggle;
  bump: number;
  reserved: Array<number>;
};

export type OperatorVaultTicketArgs = {
  discriminator: number | bigint;
  operator: Address;
  vault: Address;
  index: number | bigint;
  state: SlotToggleArgs;
  bump: number;
  reserved: Array<number>;
};

export function getOperatorVaultTicketEncoder(): Encoder<OperatorVaultTicketArgs> {
  return getStructEncoder([
    ['discriminator', getU64Encoder()],
    ['operator', getAddressEncoder()],
    ['vault', getAddressEncoder()],
    ['index', getU64Encoder()],
    ['state', getSlotToggleEncoder()],
    ['bump', getU8Encoder()],
    ['reserved', getArrayEncoder(getU8Encoder(), { size: 263 })],
  ]);
}

export function getOperatorVaultTicketDecoder(): Decoder<OperatorVaultTicket> {
  return getStructDecoder([
    ['discriminator', getU64Decoder()],
    ['operator', getAddressDecoder()],
    ['vault', getAddressDecoder()],
    ['index', getU64Decoder()],
    ['state', getSlotToggleDecoder()],
    ['bump', getU8Decoder()],
    ['reserved', getArrayDecoder(getU8Decoder(), { size: 263 })],
  ]);
}

export function getOperatorVaultTicketCodec(): Codec<
  OperatorVaultTicketArgs,
  OperatorVaultTicket
> {
  return combineCodec(
    getOperatorVaultTicketEncoder(),
    getOperatorVaultTicketDecoder()
  );
}

export function decodeOperatorVaultTicket<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress>
): Account<OperatorVaultTicket, TAddress>;
export function decodeOperatorVaultTicket<TAddress extends string = string>(
  encodedAccount: MaybeEncodedAccount<TAddress>
): MaybeAccount<OperatorVaultTicket, TAddress>;
export function decodeOperatorVaultTicket<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress> | MaybeEncodedAccount<TAddress>
):
  | Account<OperatorVaultTicket, TAddress>
  | MaybeAccount<OperatorVaultTicket, TAddress> {
  return decodeAccount(
    encodedAccount as MaybeEncodedAccount<TAddress>,
    getOperatorVaultTicketDecoder()
  );
}

export async function fetchOperatorVaultTicket<
  TAddress extends string = string,
>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<Account<OperatorVaultTicket, TAddress>> {
  const maybeAccount = await fetchMaybeOperatorVaultTicket(
    rpc,
    address,
    config
  );
  assertAccountExists(maybeAccount);
  return maybeAccount;
}

export async function fetchMaybeOperatorVaultTicket<
  TAddress extends string = string,
>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<MaybeAccount<OperatorVaultTicket, TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeOperatorVaultTicket(maybeAccount);
}

export async function fetchAllOperatorVaultTicket(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<Account<OperatorVaultTicket>[]> {
  const maybeAccounts = await fetchAllMaybeOperatorVaultTicket(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}

export async function fetchAllMaybeOperatorVaultTicket(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<MaybeAccount<OperatorVaultTicket>[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) =>
    decodeOperatorVaultTicket(maybeAccount)
  );
}
