/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  combineCodec,
  getStructDecoder,
  getStructEncoder,
  getU8Decoder,
  getU8Encoder,
  transformEncoder,
  type Address,
  type Codec,
  type Decoder,
  type Encoder,
  type IAccountMeta,
  type IAccountSignerMeta,
  type IInstruction,
  type IInstructionWithAccounts,
  type IInstructionWithData,
  type ReadonlyAccount,
  type ReadonlySignerAccount,
  type TransactionSigner,
  type WritableAccount,
} from '@solana/web3.js';
import { JITO_RESTAKING_PROGRAM_ADDRESS } from '../programs';
import { getAccountMetaFactory, type ResolvedAccount } from '../shared';

export const COOLDOWN_NCN_VAULT_TICKET_DISCRIMINATOR = 8;

export function getCooldownNcnVaultTicketDiscriminatorBytes() {
  return getU8Encoder().encode(COOLDOWN_NCN_VAULT_TICKET_DISCRIMINATOR);
}

export type CooldownNcnVaultTicketInstruction<
  TProgram extends string = typeof JITO_RESTAKING_PROGRAM_ADDRESS,
  TAccountConfig extends string | IAccountMeta<string> = string,
  TAccountNcn extends string | IAccountMeta<string> = string,
  TAccountVault extends string | IAccountMeta<string> = string,
  TAccountNcnVaultTicket extends string | IAccountMeta<string> = string,
  TAccountAdmin extends string | IAccountMeta<string> = string,
  TRemainingAccounts extends readonly IAccountMeta<string>[] = [],
> = IInstruction<TProgram> &
  IInstructionWithData<Uint8Array> &
  IInstructionWithAccounts<
    [
      TAccountConfig extends string
        ? ReadonlyAccount<TAccountConfig>
        : TAccountConfig,
      TAccountNcn extends string ? ReadonlyAccount<TAccountNcn> : TAccountNcn,
      TAccountVault extends string
        ? ReadonlyAccount<TAccountVault>
        : TAccountVault,
      TAccountNcnVaultTicket extends string
        ? WritableAccount<TAccountNcnVaultTicket>
        : TAccountNcnVaultTicket,
      TAccountAdmin extends string
        ? ReadonlySignerAccount<TAccountAdmin> &
            IAccountSignerMeta<TAccountAdmin>
        : TAccountAdmin,
      ...TRemainingAccounts,
    ]
  >;

export type CooldownNcnVaultTicketInstructionData = { discriminator: number };

export type CooldownNcnVaultTicketInstructionDataArgs = {};

export function getCooldownNcnVaultTicketInstructionDataEncoder(): Encoder<CooldownNcnVaultTicketInstructionDataArgs> {
  return transformEncoder(
    getStructEncoder([['discriminator', getU8Encoder()]]),
    (value) => ({
      ...value,
      discriminator: COOLDOWN_NCN_VAULT_TICKET_DISCRIMINATOR,
    })
  );
}

export function getCooldownNcnVaultTicketInstructionDataDecoder(): Decoder<CooldownNcnVaultTicketInstructionData> {
  return getStructDecoder([['discriminator', getU8Decoder()]]);
}

export function getCooldownNcnVaultTicketInstructionDataCodec(): Codec<
  CooldownNcnVaultTicketInstructionDataArgs,
  CooldownNcnVaultTicketInstructionData
> {
  return combineCodec(
    getCooldownNcnVaultTicketInstructionDataEncoder(),
    getCooldownNcnVaultTicketInstructionDataDecoder()
  );
}

export type CooldownNcnVaultTicketInput<
  TAccountConfig extends string = string,
  TAccountNcn extends string = string,
  TAccountVault extends string = string,
  TAccountNcnVaultTicket extends string = string,
  TAccountAdmin extends string = string,
> = {
  config: Address<TAccountConfig>;
  ncn: Address<TAccountNcn>;
  vault: Address<TAccountVault>;
  ncnVaultTicket: Address<TAccountNcnVaultTicket>;
  admin: TransactionSigner<TAccountAdmin>;
};

export function getCooldownNcnVaultTicketInstruction<
  TAccountConfig extends string,
  TAccountNcn extends string,
  TAccountVault extends string,
  TAccountNcnVaultTicket extends string,
  TAccountAdmin extends string,
>(
  input: CooldownNcnVaultTicketInput<
    TAccountConfig,
    TAccountNcn,
    TAccountVault,
    TAccountNcnVaultTicket,
    TAccountAdmin
  >
): CooldownNcnVaultTicketInstruction<
  typeof JITO_RESTAKING_PROGRAM_ADDRESS,
  TAccountConfig,
  TAccountNcn,
  TAccountVault,
  TAccountNcnVaultTicket,
  TAccountAdmin
> {
  // Program address.
  const programAddress = JITO_RESTAKING_PROGRAM_ADDRESS;

  // Original accounts.
  const originalAccounts = {
    config: { value: input.config ?? null, isWritable: false },
    ncn: { value: input.ncn ?? null, isWritable: false },
    vault: { value: input.vault ?? null, isWritable: false },
    ncnVaultTicket: { value: input.ncnVaultTicket ?? null, isWritable: true },
    admin: { value: input.admin ?? null, isWritable: false },
  };
  const accounts = originalAccounts as Record<
    keyof typeof originalAccounts,
    ResolvedAccount
  >;

  const getAccountMeta = getAccountMetaFactory(programAddress, 'programId');
  const instruction = {
    accounts: [
      getAccountMeta(accounts.config),
      getAccountMeta(accounts.ncn),
      getAccountMeta(accounts.vault),
      getAccountMeta(accounts.ncnVaultTicket),
      getAccountMeta(accounts.admin),
    ],
    programAddress,
    data: getCooldownNcnVaultTicketInstructionDataEncoder().encode({}),
  } as CooldownNcnVaultTicketInstruction<
    typeof JITO_RESTAKING_PROGRAM_ADDRESS,
    TAccountConfig,
    TAccountNcn,
    TAccountVault,
    TAccountNcnVaultTicket,
    TAccountAdmin
  >;

  return instruction;
}

export type ParsedCooldownNcnVaultTicketInstruction<
  TProgram extends string = typeof JITO_RESTAKING_PROGRAM_ADDRESS,
  TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[],
> = {
  programAddress: Address<TProgram>;
  accounts: {
    config: TAccountMetas[0];
    ncn: TAccountMetas[1];
    vault: TAccountMetas[2];
    ncnVaultTicket: TAccountMetas[3];
    admin: TAccountMetas[4];
  };
  data: CooldownNcnVaultTicketInstructionData;
};

export function parseCooldownNcnVaultTicketInstruction<
  TProgram extends string,
  TAccountMetas extends readonly IAccountMeta[],
>(
  instruction: IInstruction<TProgram> &
    IInstructionWithAccounts<TAccountMetas> &
    IInstructionWithData<Uint8Array>
): ParsedCooldownNcnVaultTicketInstruction<TProgram, TAccountMetas> {
  if (instruction.accounts.length < 5) {
    // TODO: Coded error.
    throw new Error('Not enough accounts');
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts![accountIndex]!;
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      config: getNextAccount(),
      ncn: getNextAccount(),
      vault: getNextAccount(),
      ncnVaultTicket: getNextAccount(),
      admin: getNextAccount(),
    },
    data: getCooldownNcnVaultTicketInstructionDataDecoder().decode(
      instruction.data
    ),
  };
}
