/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  combineCodec,
  getStructDecoder,
  getStructEncoder,
  getU8Decoder,
  getU8Encoder,
  transformEncoder,
  type Address,
  type Codec,
  type Decoder,
  type Encoder,
  type IAccountMeta,
  type IAccountSignerMeta,
  type IInstruction,
  type IInstructionWithAccounts,
  type IInstructionWithData,
  type ReadonlyAccount,
  type ReadonlySignerAccount,
  type TransactionSigner,
  type WritableAccount,
} from '@solana/web3.js';
import { JITO_RESTAKING_PROGRAM_ADDRESS } from '../programs';
import { getAccountMetaFactory, type ResolvedAccount } from '../shared';

export const COOLDOWN_OPERATOR_VAULT_TICKET_DISCRIMINATOR = 16;

export function getCooldownOperatorVaultTicketDiscriminatorBytes() {
  return getU8Encoder().encode(COOLDOWN_OPERATOR_VAULT_TICKET_DISCRIMINATOR);
}

export type CooldownOperatorVaultTicketInstruction<
  TProgram extends string = typeof JITO_RESTAKING_PROGRAM_ADDRESS,
  TAccountConfig extends string | IAccountMeta<string> = string,
  TAccountOperator extends string | IAccountMeta<string> = string,
  TAccountVault extends string | IAccountMeta<string> = string,
  TAccountOperatorVaultTicket extends string | IAccountMeta<string> = string,
  TAccountAdmin extends string | IAccountMeta<string> = string,
  TRemainingAccounts extends readonly IAccountMeta<string>[] = [],
> = IInstruction<TProgram> &
  IInstructionWithData<Uint8Array> &
  IInstructionWithAccounts<
    [
      TAccountConfig extends string
        ? ReadonlyAccount<TAccountConfig>
        : TAccountConfig,
      TAccountOperator extends string
        ? ReadonlyAccount<TAccountOperator>
        : TAccountOperator,
      TAccountVault extends string
        ? ReadonlyAccount<TAccountVault>
        : TAccountVault,
      TAccountOperatorVaultTicket extends string
        ? WritableAccount<TAccountOperatorVaultTicket>
        : TAccountOperatorVaultTicket,
      TAccountAdmin extends string
        ? ReadonlySignerAccount<TAccountAdmin> &
            IAccountSignerMeta<TAccountAdmin>
        : TAccountAdmin,
      ...TRemainingAccounts,
    ]
  >;

export type CooldownOperatorVaultTicketInstructionData = {
  discriminator: number;
};

export type CooldownOperatorVaultTicketInstructionDataArgs = {};

export function getCooldownOperatorVaultTicketInstructionDataEncoder(): Encoder<CooldownOperatorVaultTicketInstructionDataArgs> {
  return transformEncoder(
    getStructEncoder([['discriminator', getU8Encoder()]]),
    (value) => ({
      ...value,
      discriminator: COOLDOWN_OPERATOR_VAULT_TICKET_DISCRIMINATOR,
    })
  );
}

export function getCooldownOperatorVaultTicketInstructionDataDecoder(): Decoder<CooldownOperatorVaultTicketInstructionData> {
  return getStructDecoder([['discriminator', getU8Decoder()]]);
}

export function getCooldownOperatorVaultTicketInstructionDataCodec(): Codec<
  CooldownOperatorVaultTicketInstructionDataArgs,
  CooldownOperatorVaultTicketInstructionData
> {
  return combineCodec(
    getCooldownOperatorVaultTicketInstructionDataEncoder(),
    getCooldownOperatorVaultTicketInstructionDataDecoder()
  );
}

export type CooldownOperatorVaultTicketInput<
  TAccountConfig extends string = string,
  TAccountOperator extends string = string,
  TAccountVault extends string = string,
  TAccountOperatorVaultTicket extends string = string,
  TAccountAdmin extends string = string,
> = {
  config: Address<TAccountConfig>;
  operator: Address<TAccountOperator>;
  vault: Address<TAccountVault>;
  operatorVaultTicket: Address<TAccountOperatorVaultTicket>;
  admin: TransactionSigner<TAccountAdmin>;
};

export function getCooldownOperatorVaultTicketInstruction<
  TAccountConfig extends string,
  TAccountOperator extends string,
  TAccountVault extends string,
  TAccountOperatorVaultTicket extends string,
  TAccountAdmin extends string,
>(
  input: CooldownOperatorVaultTicketInput<
    TAccountConfig,
    TAccountOperator,
    TAccountVault,
    TAccountOperatorVaultTicket,
    TAccountAdmin
  >
): CooldownOperatorVaultTicketInstruction<
  typeof JITO_RESTAKING_PROGRAM_ADDRESS,
  TAccountConfig,
  TAccountOperator,
  TAccountVault,
  TAccountOperatorVaultTicket,
  TAccountAdmin
> {
  // Program address.
  const programAddress = JITO_RESTAKING_PROGRAM_ADDRESS;

  // Original accounts.
  const originalAccounts = {
    config: { value: input.config ?? null, isWritable: false },
    operator: { value: input.operator ?? null, isWritable: false },
    vault: { value: input.vault ?? null, isWritable: false },
    operatorVaultTicket: {
      value: input.operatorVaultTicket ?? null,
      isWritable: true,
    },
    admin: { value: input.admin ?? null, isWritable: false },
  };
  const accounts = originalAccounts as Record<
    keyof typeof originalAccounts,
    ResolvedAccount
  >;

  const getAccountMeta = getAccountMetaFactory(programAddress, 'programId');
  const instruction = {
    accounts: [
      getAccountMeta(accounts.config),
      getAccountMeta(accounts.operator),
      getAccountMeta(accounts.vault),
      getAccountMeta(accounts.operatorVaultTicket),
      getAccountMeta(accounts.admin),
    ],
    programAddress,
    data: getCooldownOperatorVaultTicketInstructionDataEncoder().encode({}),
  } as CooldownOperatorVaultTicketInstruction<
    typeof JITO_RESTAKING_PROGRAM_ADDRESS,
    TAccountConfig,
    TAccountOperator,
    TAccountVault,
    TAccountOperatorVaultTicket,
    TAccountAdmin
  >;

  return instruction;
}

export type ParsedCooldownOperatorVaultTicketInstruction<
  TProgram extends string = typeof JITO_RESTAKING_PROGRAM_ADDRESS,
  TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[],
> = {
  programAddress: Address<TProgram>;
  accounts: {
    config: TAccountMetas[0];
    operator: TAccountMetas[1];
    vault: TAccountMetas[2];
    operatorVaultTicket: TAccountMetas[3];
    admin: TAccountMetas[4];
  };
  data: CooldownOperatorVaultTicketInstructionData;
};

export function parseCooldownOperatorVaultTicketInstruction<
  TProgram extends string,
  TAccountMetas extends readonly IAccountMeta[],
>(
  instruction: IInstruction<TProgram> &
    IInstructionWithAccounts<TAccountMetas> &
    IInstructionWithData<Uint8Array>
): ParsedCooldownOperatorVaultTicketInstruction<TProgram, TAccountMetas> {
  if (instruction.accounts.length < 5) {
    // TODO: Coded error.
    throw new Error('Not enough accounts');
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts![accountIndex]!;
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      config: getNextAccount(),
      operator: getNextAccount(),
      vault: getNextAccount(),
      operatorVaultTicket: getNextAccount(),
      admin: getNextAccount(),
    },
    data: getCooldownOperatorVaultTicketInstructionDataDecoder().decode(
      instruction.data
    ),
  };
}
