/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  combineCodec,
  getStructDecoder,
  getStructEncoder,
  getU8Decoder,
  getU8Encoder,
  transformEncoder,
  type Address,
  type Codec,
  type Decoder,
  type Encoder,
  type IAccountMeta,
  type IAccountSignerMeta,
  type IInstruction,
  type IInstructionWithAccounts,
  type IInstructionWithData,
  type ReadonlySignerAccount,
  type TransactionSigner,
  type WritableAccount,
} from '@solana/web3.js';
import { JITO_RESTAKING_PROGRAM_ADDRESS } from '../programs';
import { getAccountMetaFactory, type ResolvedAccount } from '../shared';

export const OPERATOR_SET_ADMIN_DISCRIMINATOR = 19;

export function getOperatorSetAdminDiscriminatorBytes() {
  return getU8Encoder().encode(OPERATOR_SET_ADMIN_DISCRIMINATOR);
}

export type OperatorSetAdminInstruction<
  TProgram extends string = typeof JITO_RESTAKING_PROGRAM_ADDRESS,
  TAccountOperator extends string | IAccountMeta<string> = string,
  TAccountOldAdmin extends string | IAccountMeta<string> = string,
  TAccountNewAdmin extends string | IAccountMeta<string> = string,
  TRemainingAccounts extends readonly IAccountMeta<string>[] = [],
> = IInstruction<TProgram> &
  IInstructionWithData<Uint8Array> &
  IInstructionWithAccounts<
    [
      TAccountOperator extends string
        ? WritableAccount<TAccountOperator>
        : TAccountOperator,
      TAccountOldAdmin extends string
        ? ReadonlySignerAccount<TAccountOldAdmin> &
            IAccountSignerMeta<TAccountOldAdmin>
        : TAccountOldAdmin,
      TAccountNewAdmin extends string
        ? ReadonlySignerAccount<TAccountNewAdmin> &
            IAccountSignerMeta<TAccountNewAdmin>
        : TAccountNewAdmin,
      ...TRemainingAccounts,
    ]
  >;

export type OperatorSetAdminInstructionData = { discriminator: number };

export type OperatorSetAdminInstructionDataArgs = {};

export function getOperatorSetAdminInstructionDataEncoder(): Encoder<OperatorSetAdminInstructionDataArgs> {
  return transformEncoder(
    getStructEncoder([['discriminator', getU8Encoder()]]),
    (value) => ({ ...value, discriminator: OPERATOR_SET_ADMIN_DISCRIMINATOR })
  );
}

export function getOperatorSetAdminInstructionDataDecoder(): Decoder<OperatorSetAdminInstructionData> {
  return getStructDecoder([['discriminator', getU8Decoder()]]);
}

export function getOperatorSetAdminInstructionDataCodec(): Codec<
  OperatorSetAdminInstructionDataArgs,
  OperatorSetAdminInstructionData
> {
  return combineCodec(
    getOperatorSetAdminInstructionDataEncoder(),
    getOperatorSetAdminInstructionDataDecoder()
  );
}

export type OperatorSetAdminInput<
  TAccountOperator extends string = string,
  TAccountOldAdmin extends string = string,
  TAccountNewAdmin extends string = string,
> = {
  operator: Address<TAccountOperator>;
  oldAdmin: TransactionSigner<TAccountOldAdmin>;
  newAdmin: TransactionSigner<TAccountNewAdmin>;
};

export function getOperatorSetAdminInstruction<
  TAccountOperator extends string,
  TAccountOldAdmin extends string,
  TAccountNewAdmin extends string,
>(
  input: OperatorSetAdminInput<
    TAccountOperator,
    TAccountOldAdmin,
    TAccountNewAdmin
  >
): OperatorSetAdminInstruction<
  typeof JITO_RESTAKING_PROGRAM_ADDRESS,
  TAccountOperator,
  TAccountOldAdmin,
  TAccountNewAdmin
> {
  // Program address.
  const programAddress = JITO_RESTAKING_PROGRAM_ADDRESS;

  // Original accounts.
  const originalAccounts = {
    operator: { value: input.operator ?? null, isWritable: true },
    oldAdmin: { value: input.oldAdmin ?? null, isWritable: false },
    newAdmin: { value: input.newAdmin ?? null, isWritable: false },
  };
  const accounts = originalAccounts as Record<
    keyof typeof originalAccounts,
    ResolvedAccount
  >;

  const getAccountMeta = getAccountMetaFactory(programAddress, 'programId');
  const instruction = {
    accounts: [
      getAccountMeta(accounts.operator),
      getAccountMeta(accounts.oldAdmin),
      getAccountMeta(accounts.newAdmin),
    ],
    programAddress,
    data: getOperatorSetAdminInstructionDataEncoder().encode({}),
  } as OperatorSetAdminInstruction<
    typeof JITO_RESTAKING_PROGRAM_ADDRESS,
    TAccountOperator,
    TAccountOldAdmin,
    TAccountNewAdmin
  >;

  return instruction;
}

export type ParsedOperatorSetAdminInstruction<
  TProgram extends string = typeof JITO_RESTAKING_PROGRAM_ADDRESS,
  TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[],
> = {
  programAddress: Address<TProgram>;
  accounts: {
    operator: TAccountMetas[0];
    oldAdmin: TAccountMetas[1];
    newAdmin: TAccountMetas[2];
  };
  data: OperatorSetAdminInstructionData;
};

export function parseOperatorSetAdminInstruction<
  TProgram extends string,
  TAccountMetas extends readonly IAccountMeta[],
>(
  instruction: IInstruction<TProgram> &
    IInstructionWithAccounts<TAccountMetas> &
    IInstructionWithData<Uint8Array>
): ParsedOperatorSetAdminInstruction<TProgram, TAccountMetas> {
  if (instruction.accounts.length < 3) {
    // TODO: Coded error.
    throw new Error('Not enough accounts');
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts![accountIndex]!;
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      operator: getNextAccount(),
      oldAdmin: getNextAccount(),
      newAdmin: getNextAccount(),
    },
    data: getOperatorSetAdminInstructionDataDecoder().decode(instruction.data),
  };
}
